//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
#include "aria.hpp"
#include "Global.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TComboBox *cbxKeyBits;
  TLabel *lblKeyBits;
  TLabel *lblMasterKey;
  TEdit *edMasterKey;
  TButton *btnGenerateRandomMasterKey;
  TLabel *lblCryptType;
  TComboBox *cbxCryptType;
  TButton *btnInitialize;
  TButton *btnFinalize;
  TMemo *mmInput;
  TMemo *mmOutput;
  TButton *btnCrypt;
  TLabel *lblInput;
  TLabel *lblOutput;
  TBevel *Bevel1;
  TBevel *Bevel2;
  TSpeedButton *sbtAbout;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall btnInitializeClick(TObject *Sender);
  void __fastcall btnGenerateRandomMasterKeyClick(TObject *Sender);
  void __fastcall btnFinalizeClick(TObject *Sender);
  void __fastcall btnCryptClick(TObject *Sender);
  void __fastcall ComboBoxClick(TObject *Sender);
  void __fastcall EditChange(TObject *Sender);
  void __fastcall MemoChange(TObject *Sender);
  void __fastcall sbtAboutClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);
public:
  Aria aria;
  bool initialized;
  void loadControl();
  void saveControl();
  void setControl();
  static int bin_to_hex(unsigned char* bin, unsigned char* hex, int hexLen);
  static int hex_to_bin(unsigned char* hex, unsigned char* bin, int binLen);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
